import java.util.Vector;

//odf element stores the element name and a vector containing its attributes

public class OdfElement{
	
	private String ElementName;
	private Vector<OdfAtt> AttributeList;
	
	public OdfElement(String ElementName){
		this.ElementName = ElementName;
		AttributeList = new Vector<OdfAtt>();
	}
	
	public void addAtt(OdfAtt attribute){
		AttributeList.add(attribute);
	}
	
	public String toString(){
		String attString = new String();
		for (int i = 0; i <AttributeList.size();i++){
			String a = new String((AttributeList.get(i).toString()));
			attString = attString.concat(a);
		}
		String s = new String(ElementName+"- "+attString);
		return s;
	}
	
	public String getElementName(){
		return ElementName;
	}
	
	public String getAttValue(String searchTerm){
		//search through the vector
		String result = " ";
		for (int i = 0; i <AttributeList.size();i++){
			OdfAtt a = AttributeList.get(i);
			String attName = a.getAttName();
			//if the search term matches the attribute name, return the attributes value
			if (attName.equals(searchTerm)){
				result = a.getAttValue();
				break;
			}
		}
		return result;
	}
}