import java.sql.*;
import javax.swing.tree.*;

public class OdfProcessor{

	private Connection con;
	private Statement st;
	private String DocType;
	private String DocCode;
	private DefaultMutableTreeNode current;
	private String sql;

	public OdfProcessor(){
		init();
	}
	
	public void init(){
		try {
			Class.forName("com.mysql.jdbc.Driver");
			con = DriverManager.getConnection("jdbc:mysql://localhost/odf", "root", "H3liC0pter");
			st = con.createStatement();
			/*
			String sql = ("INSERT INTO ATHLETES VALUES('1234567','Smith','Bob','M','1990-09-18','ESP')");
			st.executeUpdate(sql);
			System.out.println("Connected to the database");
			con.close();
			System.out.println("Disconnected from database");
			*/
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
		
	public void process(DefaultTreeModel tree){
		//get the root
		current = (DefaultMutableTreeNode)tree.getRoot();
		//go to child and get document type and event code
		current = (DefaultMutableTreeNode)current.getFirstChild();
		OdfElement o =(OdfElement) current.getUserObject();
		DocType = o.getAttValue("DocumentType");
		DocCode = o.getAttValue("DocumentCode");
		//call processing instructions depending on Document Type
		if (DocType.equals("DT_PARTIC") || DocType.equals("DT_PARTIC_UPDATE")){
			processDT_PARTIC(current);
		}
		else if (DocType.equals("DT_PARTIC_TEAMS") || DocType.equals("DT_PARTIC_TEAMS_UPDATE")){
			processDT_PARTIC_TEAMS(current);
		}
		else if (DocType.equals("DT_START_LIST")){
			processDT_START_LIST(current);
		}
	}
	
	public void processDT_PARTIC(DefaultMutableTreeNode current2){
		//go to child node (OdfBody)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		//go to child node (Participant)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		String athleteFunction;
		String athleteAccred;
		//loop through all participants
		//if the particpants is an accredited athlete, insert data
		for(int i = 0; i < current2.getSiblingCount();i++){
			OdfElement o =(OdfElement) current2.getUserObject();
			athleteFunction = o.getAttValue("MainFunctionId");
			athleteAccred = o.getAttValue("Status");
			if(athleteFunction.equals("AA01") && athleteAccred.equals("ACCRED") ){
				String athleteCode = o.getAttValue("Code");
				String athleteFName = o.getAttValue("FamilyName");
				String athleteGName = o.getAttValue("GivenName");
				String athleteGender = o.getAttValue("Gender");
				String athleteDOB = o.getAttValue("BirthDate");
				athleteDOB = new StringBuffer(athleteDOB).insert(4, "-").toString(); //convert DOB to correct format
				athleteDOB = new StringBuffer(athleteDOB).insert(7, "-").toString();
				String athleteOrg = o.getAttValue("Organisation");
						
				//SQL insert
				sql = ("INSERT INTO ATHLETES VALUES('"
						+athleteCode+"','"
						+athleteFName+"','"
						+athleteGName+"','"
						+athleteGender+"','"
						+athleteDOB+"','"
						+athleteOrg+"')");
				try{
					st.executeUpdate(sql);
				}
				catch (Exception e){
					e.printStackTrace();
				}
			}
			//move to next sibling node, if not the last node
			if( i != current2.getSiblingCount()-1){
				current2 = (DefaultMutableTreeNode)current2.getNextSibling();
			}
		}
	}
		
	public void processDT_PARTIC_TEAMS(DefaultMutableTreeNode current2){
		//go to child node (OdfBody)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		//go to child node (Team)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		//loop through teams
		for(int i = 0; i < current2.getSiblingCount();i++){
			OdfElement o =(OdfElement) current2.getUserObject();
			String teamCode = o.getAttValue("Code");
			String teamOrg = o.getAttValue("Organisation");
			String teamName = o.getAttValue("Name");
			//go to childe node (Composition)
			current2 = (DefaultMutableTreeNode)current2.getFirstChild();
			//go to childe node (Athlete)
			current2 = (DefaultMutableTreeNode)current2.getFirstChild();
			o =(OdfElement) current2.getUserObject();
			String teamAthlete1 = o.getAttValue("Code");
			current2 = (DefaultMutableTreeNode)current2.getNextSibling();
			o =(OdfElement) current2.getUserObject();
			String teamAthlete2 = o.getAttValue("Code");
			//back to Team node
			current2 = (DefaultMutableTreeNode)current2.getParent();
			current2 = (DefaultMutableTreeNode)current2.getParent();
			
			//SQL insert
				sql = ("INSERT INTO TEAMS VALUES('"
						+teamCode+"','"
						+teamOrg+"','"
						+teamName+"','"
						+teamAthlete1+"','"
						+teamAthlete2+"')");
				try{
					st.executeUpdate(sql);
				}
				catch (Exception e){
					e.printStackTrace();
				}
			
			//move to next sibling node, if not the last node
			if( i != current2.getSiblingCount()-1){
				current2 = (DefaultMutableTreeNode)current2.getNextSibling();
			}
		}
	}
	
	public void processDT_START_LIST(DefaultMutableTreeNode current2){
		//go to child node (OdfBody)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		//go to child node (UnitInfos-same level as start)
		current2 = (DefaultMutableTreeNode)current2.getFirstChild();
		//loop through nodes
		for(int i = 0; i < current2.getSiblingCount();i++){
			OdfElement o =(OdfElement) current2.getUserObject();
			//if the element is "start"
			if(o.getElementName().equals("Start")){
				//get start order
				String startOrder = o.getAttValue("StartOrder");
				//go to next child and get competitor code
				current2 = (DefaultMutableTreeNode)current2.getFirstChild();
				o =(OdfElement) current2.getUserObject();
				String competitorCode = o.getAttValue("Code");
						
				//insert start list into results
				sql = ("INSERT INTO RESULTS VALUES('"
						+DocCode+"','"
						+competitorCode+"','"
						+startOrder+"')");
				try{
					st.executeUpdate(sql);
				}
				catch (Exception e){
					e.printStackTrace();
				}
				
				
				//DIVES
				String diveCode1 = "none";
				String diveDiff1 = "none";
				String diveDesc1 = "none";
				String diveCode2 = "none";
				String diveDiff2 = "none";
				String diveDesc2 = "none";
				String diveCode3 = "none";
				String diveDiff3 = "none";
				String diveDesc3 = "none";
				String diveCode4 = "none";
				String diveDiff4 = "none";
				String diveDesc4 = "none";
				String diveCode5 = "none";
				String diveDiff5 = "none";
				String diveDesc5 = "none";
				String diveCode6 = "none";
				String diveDiff6 = "none";
				String diveDesc6 = "none";
				current2 = (DefaultMutableTreeNode)current2.getFirstChild();
				for(int j = 0; j < current2.getSiblingCount();j++){


					o =(OdfElement) current2.getUserObject();
					if(o.getElementName().equals("EventUnitEntry")){
						if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("1"))){
							diveCode1 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("1"))){
							diveDiff1 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("1"))){
							diveDesc1 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("2"))){
							diveCode2 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("2"))){
							diveDiff2 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("2"))){
							diveDesc2 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("3"))){
							diveCode3 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("3"))){
							diveDiff3 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("3"))){
							diveDesc3 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("4"))){
							diveCode4 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("4"))){
							diveDiff4 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("4"))){
							diveDesc4 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("5"))){
							diveCode5 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("5"))){
							diveDiff5 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("5"))){
							diveDesc5 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_NUMBER") && (o.getAttValue("Pos").equals("6"))){
							diveCode6 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DD") && (o.getAttValue("Pos").equals("6"))){
							diveDiff6 = o.getAttValue("Value");
						}
						else if(o.getAttValue("Code").equals("DV_DESCRIPTION") && (o.getAttValue("Pos").equals("6"))){
							diveDesc6 = o.getAttValue("Value");
						}					
					
					}
					//go to next sibling 
					if( j != current2.getSiblingCount()-1){
						current2 = (DefaultMutableTreeNode)current2.getNextSibling();
					}
				
				}
				//insert dives
				//if dive 6 is none, then insert 5 dives, else insert 6
				if (diveCode6.equals("none")){
					sql = ("INSERT INTO DIVES (competitor,dive_number,dive_code,description,difficulty) VALUES ('"
						+competitorCode+"','1','"
						+diveCode1+"','"
						+diveDesc1+"','"
						+diveDiff1+"'),('"		
						+competitorCode+"','2','"
						+diveCode2+"','"
						+diveDesc2+"','"
						+diveDiff2+"'),('"
						+competitorCode+"','3','"
						+diveCode3+"','"
						+diveDesc3+"','"
						+diveDiff3+"'),('"	
						+competitorCode+"','4','"
						+diveCode4+"','"
						+diveDesc4+"','"
						+diveDiff4+"'),('"	
						+competitorCode+"','5','"
						+diveCode5+"','"
						+diveDesc5+"','"
						+diveDiff5+"')");			
				}
				else{
					sql = ("INSERT INTO DIVES (competitor,dive_number,dive_code,description,difficulty) VALUES ('"
						+competitorCode+"','1','"
						+diveCode1+"','"
						+diveDesc1+"','"
						+diveDiff1+"'),('"		
						+competitorCode+"','2','"
						+diveCode2+"','"
						+diveDesc2+"','"
						+diveDiff2+"'),('"
						+competitorCode+"','3','"
						+diveCode3+"','"
						+diveDesc3+"','"
						+diveDiff3+"'),('"	
						+competitorCode+"','4','"
						+diveCode4+"','"
						+diveDesc4+"','"
						+diveDiff4+"'),('"	
						+competitorCode+"','5','"
						+diveCode5+"','"
						+diveDesc5+"','"
						+diveDiff5+"'),('"
						+competitorCode+"','6','"
						+diveCode6+"','"
						+diveDesc6+"','"
						+diveDiff6+"')");							
				}
					try{
						st.executeUpdate(sql);
					}
					catch (Exception e){
						e.printStackTrace();
					}
				
				current2 = (DefaultMutableTreeNode)current2.getParent();
				//END OF DIVE PROCESSING
				
				
				
				
				
				
				//back to "start" nodes
				current2 = (DefaultMutableTreeNode)current2.getParent();
			}
			if( i != current2.getSiblingCount()-1){
				current2 = (DefaultMutableTreeNode)current2.getNextSibling();
			}
		}	
	}
}